Index: /LMDZ4/trunk/libf/phylmd/interface_surf.F90
===================================================================
--- /LMDZ4/trunk/libf/phylmd/interface_surf.F90	(revision 765)
+++ /LMDZ4/trunk/libf/phylmd/interface_surf.F90	(revision 766)
@@ -1839,5 +2096,5 @@
 ! transformer read_sic en pctsrf_sav
 !
-      call cpl2gath(read_sic, tamp_sic , klon, klon,iim,jjm, unity)
+      call cpl2gath(read_sic, tamp_sic , klon, klon,iim,jjphy_nb, unity)
       do ig = 1, klon
         IF (pctsrf(ig,is_oce) > epsfra .OR.            &
@@ -1882,16 +2139,16 @@
     if (nisurf == is_oce .and. (.not. cumul) ) then
       sum_error = 0
-      allocate(tmp_sols(iim,jjm+1,2), stat=error); sum_error = sum_error + error
-      allocate(tmp_nsol(iim,jjm+1,2), stat=error); sum_error = sum_error + error
-      allocate(tmp_rain(iim,jjm+1,2), stat=error); sum_error = sum_error + error
-      allocate(tmp_snow(iim,jjm+1,2), stat=error); sum_error = sum_error + error
-      allocate(tmp_evap(iim,jjm+1,2), stat=error); sum_error = sum_error + error
-      allocate(tmp_tsol(iim,jjm+1,2), stat=error); sum_error = sum_error + error
-      allocate(tmp_fder(iim,jjm+1,2), stat=error); sum_error = sum_error + error
-      allocate(tmp_albe(iim,jjm+1,2), stat=error); sum_error = sum_error + error
-      allocate(tmp_taux(iim,jjm+1,2), stat=error); sum_error = sum_error + error
-      allocate(tmp_tauy(iim,jjm+1,2), stat=error); sum_error = sum_error + error
-! -- LOOP
-       allocate(tmp_windsp(iim,jjm+1,2), stat=error); sum_error = sum_error + error
+      allocate(tmp_sols(iim,jjphy_nb,2), stat=error); sum_error = sum_error + error
+      allocate(tmp_nsol(iim,jjphy_nb,2), stat=error); sum_error = sum_error + error
+      allocate(tmp_rain(iim,jjphy_nb,2), stat=error); sum_error = sum_error + error
+      allocate(tmp_snow(iim,jjphy_nb,2), stat=error); sum_error = sum_error + error
+      allocate(tmp_evap(iim,jjphy_nb,2), stat=error); sum_error = sum_error + error
+      allocate(tmp_tsol(iim,jjphy_nb,2), stat=error); sum_error = sum_error + error
+      allocate(tmp_fder(iim,jjphy_nb,2), stat=error); sum_error = sum_error + error
+      allocate(tmp_albe(iim,jjphy_nb,2), stat=error); sum_error = sum_error + error
+      allocate(tmp_taux(iim,jjphy_nb,2), stat=error); sum_error = sum_error + error
+      allocate(tmp_tauy(iim,jjphy_nb,2), stat=error); sum_error = sum_error + error
+! -- LOOP
+       allocate(tmp_windsp(iim,jjphy_nb,2), stat=error); sum_error = sum_error + error
 ! -- LOOP
 !!$      allocate(tmp_rriv(iim,jjm+1,2), stat=error); sum_error = sum_error + error
@@ -1908,17 +2165,17 @@
     cpl_index = 1
     if (nisurf == is_sic) cpl_index = 2
-    call gath2cpl(cpl_sols(1,cpl_index), tmp_sols(1,1,cpl_index), klon, knon,iim,jjm,                  knindex)
-    call gath2cpl(cpl_nsol(1,cpl_index), tmp_nsol(1,1,cpl_index), klon, knon,iim,jjm,                  knindex)
-    call gath2cpl(cpl_rain(1,cpl_index), tmp_rain(1,1,cpl_index), klon, knon,iim,jjm,                  knindex)
-    call gath2cpl(cpl_snow(1,cpl_index), tmp_snow(1,1,cpl_index), klon, knon,iim,jjm,                  knindex)
-    call gath2cpl(cpl_evap(1,cpl_index), tmp_evap(1,1,cpl_index), klon, knon,iim,jjm,                  knindex)
-    call gath2cpl(cpl_tsol(1,cpl_index), tmp_tsol(1,1,cpl_index), klon, knon,iim,jjm,                  knindex)
-    call gath2cpl(cpl_fder(1,cpl_index), tmp_fder(1,1,cpl_index), klon, knon,iim,jjm,                  knindex)
-    call gath2cpl(cpl_albe(1,cpl_index), tmp_albe(1,1,cpl_index), klon, knon,iim,jjm,                  knindex)
-    call gath2cpl(cpl_taux(1,cpl_index), tmp_taux(1,1,cpl_index), klon, knon,iim,jjm,                  knindex)
-! -- LOOP
-     call gath2cpl(cpl_windsp(1,cpl_index), tmp_windsp(1,1,cpl_index), klon, knon,iim,jjm,             knindex)
-! -- LOOP
-    call gath2cpl(cpl_tauy(1,cpl_index), tmp_tauy(1,1,cpl_index), klon, knon,iim,jjm,                  knindex)
+    call gath2cpl(cpl_sols(1,cpl_index), tmp_sols(1,1,cpl_index), klon, knon,iim,jjphy_nb,                  knindex)
+    call gath2cpl(cpl_nsol(1,cpl_index), tmp_nsol(1,1,cpl_index), klon, knon,iim,jjphy_nb,                  knindex)
+    call gath2cpl(cpl_rain(1,cpl_index), tmp_rain(1,1,cpl_index), klon, knon,iim,jjphy_nb,                  knindex)
+    call gath2cpl(cpl_snow(1,cpl_index), tmp_snow(1,1,cpl_index), klon, knon,iim,jjphy_nb,                  knindex)
+    call gath2cpl(cpl_evap(1,cpl_index), tmp_evap(1,1,cpl_index), klon, knon,iim,jjphy_nb,                  knindex)
+    call gath2cpl(cpl_tsol(1,cpl_index), tmp_tsol(1,1,cpl_index), klon, knon,iim,jjphy_nb,                  knindex)
+    call gath2cpl(cpl_fder(1,cpl_index), tmp_fder(1,1,cpl_index), klon, knon,iim,jjphy_nb,                  knindex)
+    call gath2cpl(cpl_albe(1,cpl_index), tmp_albe(1,1,cpl_index), klon, knon,iim,jjphy_nb,                  knindex)
+    call gath2cpl(cpl_taux(1,cpl_index), tmp_taux(1,1,cpl_index), klon, knon,iim,jjphy_nb,                  knindex)
+    call gath2cpl(cpl_tauy(1,cpl_index), tmp_tauy(1,1,cpl_index), klon, knon,iim,jjphy_nb,                  knindex)
+! -- LOOP
+     call gath2cpl(cpl_windsp(1,cpl_index), tmp_windsp(1,1,cpl_index), klon, knon,iim,jjphy_nb,            knindex)
+! -- LOOP
 
 !
@@ -1931,6 +2188,6 @@
        wri_windsp = 0.
 ! -- LOOP      
-      call gath2cpl(pctsrf(1,is_oce), tamp_srf(1,1,1), klon, klon, iim, jjm, tamp_ind)
-      call gath2cpl(pctsrf(1,is_sic), tamp_srf(1,1,2), klon, klon, iim, jjm, tamp_ind)
+      call gath2cpl(pctsrf(1,is_oce), tamp_srf(1,1,1), klon, klon, iim, jjphy_nb, tamp_ind)
+      call gath2cpl(pctsrf(1,is_sic), tamp_srf(1,1,2), klon, klon, iim, jjphy_nb, tamp_ind)
 
       wri_sol_ice = tmp_sols(:,:,2)
@@ -1948,8 +2205,52 @@
       wri_rriv = cpl_rriv(:,:)
       wri_rcoa = cpl_rcoa(:,:)
-      DO j = 1, jjm + 1
-        wri_calv(:,j) = sum(cpl_rlic(:,j)) / iim
-      enddo
-
+
+!ym  !! ATTENTION ICI
+      
+!ym      DO j = 1, jjm + 1
+!ym        wri_calv(:,j) = sum(cpl_rlic(:,j)) / iim
+!ym      enddo
+
+!Essai OM+JLD : ca marche !!!! (17 mars 2006)
+      tamp_srf(:,:,3)=0.
+      CALL gath2cpl( pctsrf(1,is_lic), tamp_srf(1,1,3), klon, klon, iim, jjphy_nb, tamp_ind)
+
+!YM pour retrouver resultat avant tamp_srf(:,3)=1.
+      
+      DO j = 1, jjphy_nb
+         wri_calv(:,j) = DOT_PRODUCT (cpl_rlic(1:iim,j), tamp_srf(1:iim,j,3)) / REAL(iim)
+      ENDDO
+
+!ym      wri_calv(:,:)=0.
+!ym      DO j = 1, jjphy_nb
+!ym        wri_calv(:,j) = sum(cpl_rlic(:,j))/iim
+!ym      enddo
+
+      IF (.NOT. monocpu) THEN
+        if (phy_rank /= 0) then
+#ifdef CPP_PARA
+          call MPI_RECV(Up,1,MPI_REAL8,phy_rank-1,1234,COMM_LMDZ,status,ierr)
+          call MPI_SEND(wri_calv(1,1),1,MPI_REAL8,phy_rank-1,1234,COMM_LMDZ,ierr)
+#endif
+        endif
+        
+        if (phy_rank /= phy_size-1) then
+#ifdef CPP_PARA
+          call MPI_SEND(wri_calv(1,jjphy_nb),1,MPI_REAL8,phy_rank+1,1234,COMM_LMDZ,ierr)  
+          call MPI_RECV(down,1,MPI_REAL8,phy_rank+1,1234,COMM_LMDZ,status,ierr)
+#endif
+        endif
+  	
+        if (phy_rank /=0 .and. iiphy_begin /=1) then
+          Up=Up+wri_calv(iim,1)
+	  wri_calv(:,1)=Up
+        endif
+      
+        if (phy_rank /=phy_size-1 .and. iiphy_end /= iim) then
+          Down=Down+wri_calv(1,jjphy_nb)
+	  wri_calv(:,jjphy_nb)=Down	 
+        endif
+      ENDIF
+      
       where (tamp_zmasq /= 1.)
         deno =  tamp_srf(:,:,1) + tamp_srf(:,:,2)
@@ -1970,27 +2271,32 @@
 !      wri_calv = coeff_iceberg * cte_flux_iceberg / (num_antarctic * surf_maille)
 !
-! on passe les coordonnées de la grille
-!
-
-      CALL gr_fi_ecrit(1,klon,iim,jjm+1,rlon,tmp_lon)
-      CALL gr_fi_ecrit(1,klon,iim,jjm+1,rlat,tmp_lat)
-
-      DO i = 1, iim
-        tmp_lon(i,1) = rlon(i+1)
-        tmp_lon(i,jjm + 1) = rlon(i+1)
-      ENDDO
+! on passe les coordonnees de la grille
+!
+
+!ym      CALL gr_fi_ecrit(1,klon,iim,jjm+1,rlon,tmp_lon)
+!ym      CALL gr_fi_ecrit(1,klon,iim,jjm+1,rlat,tmp_lat)
+
+      CALL phy2dyn(rlon,tmp_lon,1)
+      CALL phy2dyn(rlat,tmp_lat,1)
+      
+!ym      DO i = 1, iim
+!ym        tmp_lon(i,1) = rlon(i+1)
+!ym        tmp_lon(i,jjm + 1) = rlon(i+1)
+!ym      ENDDO
+
 !
 ! sortie netcdf des champs pour le changement de repere
 !
-      ndexct(:)=0
-      CALL histwrite(nidct,'tauxe',itau_w,wri_taux,iim*(jjm+1),ndexct)
-      CALL histwrite(nidct,'tauyn',itau_w,wri_tauy,iim*(jjm+1),ndexct)
-      CALL histwrite(nidct,'tmp_lon',itau_w,tmp_lon,iim*(jjm+1),ndexct)
-      CALL histwrite(nidct,'tmp_lat',itau_w,tmp_lat,iim*(jjm+1),ndexct)
-
-!
-! calcul 3 coordonnées du vent
-!
-      CALL atm2geo (iim , jjm + 1, wri_taux, wri_tauy, tmp_lon, tmp_lat, &
+      IF (monocpu) THEN
+        ndexct(:)=0
+        CALL histwrite(nidct,'tauxe',itau_w,wri_taux,iim*(jjm+1),ndexct)
+        CALL histwrite(nidct,'tauyn',itau_w,wri_tauy,iim*(jjm+1),ndexct)
+        CALL histwrite(nidct,'tmp_lon',itau_w,tmp_lon,iim*(jjm+1),ndexct)
+        CALL histwrite(nidct,'tmp_lat',itau_w,tmp_lat,iim*(jjm+1),ndexct)
+      ENDIF  
+!
+! calcul 3 coordonnees du vent
+!
+      CALL atm2geo (iim , jjphy_nb, wri_taux, wri_tauy, tmp_lon, tmp_lat, &
          & wri_tauxx, wri_tauyy, wri_tauzz )
 !
@@ -1998,4 +2304,5 @@
 ! envoi au coupleur
 !
+    IF (monocpu) THEN
       CALL histwrite(nidct,cl_writ(8),itau_w,wri_sol_ice,iim*(jjm+1),ndexct)
       CALL histwrite(nidct,cl_writ(9),itau_w,wri_sol_sea,iim*(jjm+1),ndexct)
@@ -2020,9 +2327,10 @@
 ! -- LOOP
       CALL histsync(nidct)
+    ENDIF
 ! pas utile      IF (lafin) CALL histclo(nidct)
 #ifdef CPP_COUPLE
 #ifdef CPP_PSMILE
       il_time_secs=(itime-1)*dtime
-
+      
       CALL intocpl(il_time_secs, iim, jjm+1, wri_sol_ice, wri_sol_sea, wri_nsol_ice,&
       & wri_nsol_sea, wri_fder_ice, wri_evap_ice, wri_evap_sea, wri_rain, &
@@ -2081,11 +2389,49 @@
 !
   if (nisurf == is_oce) then
-    call cpl2gath(read_sst, tsurf_new, klon, knon,iim,jjm, knindex)
+    call cpl2gath(read_sst, tsurf_new, klon, knon,iim,jjphy_nb, knindex)
   else if (nisurf == is_sic) then
-    call cpl2gath(read_sit, tsurf_new, klon, knon,iim,jjm, knindex)
-    call cpl2gath(read_alb_sic, alb_new, klon, knon,iim,jjm, knindex)
+    call cpl2gath(read_sit, tsurf_new, klon, knon,iim,jjphy_nb, knindex)
+    call cpl2gath(read_alb_sic, alb_new, klon, knon,iim,jjphy_nb, knindex)
   endif
   pctsrf_new(:,nisurf) = pctsrf_sav(:,nisurf)
   
+  if (mod(itime, nexca) == -1) then
+    tmp_field=0.
+    do i = 1, knon
+      ig = knindex(i)
+      tmp_field(ig) = 1.
+    enddo    
+!ym    call WriteField_phy('knindex',tmp_field,1)
+    
+    tmp_field=0.
+    do i = 1, knon
+      ig = knindex(i)
+      tmp_field(ig) = tsurf_new(i)
+    enddo    
+!ym    call WriteField_phy('tsurf_new',tmp_field,1)
+    
+    tmp_field=0.
+    do i = 1, knon
+      ig = knindex(i)
+      tmp_field(ig) = alb_new(i)
+    enddo    
+!ym    call WriteField_phy('alb_new',tmp_field,1)
+    
+!    tmp_field=0.
+!   do i = 1, knon
+!      ig = knindex(i)
+!      tmp_field(ig) = pctsrf_new(i,nisurf)
+ !   enddo    
+!ym    call WriteField_phy('pctsrf_new', pctsrf_new(:,nisurf),1)
+  endif
+!ym  do j=1,jjphy_nb
+!ym    do i=1,iim
+!ym      print *,phy_rank,'read_sst(',i,',',j,')=',read_sst(i,j)
+!ym    enddo
+!ym  enddo
+  
+!ym  do i=1,knon
+!ym    print *,phy_rank,'tsurf_new(',i,')=',tsurf_new(i)
+!ym  enddo
 !  if (lafin) call quitcpl
 
@@ -2140,9 +2486,13 @@
   REAL :: amn, amx
   INTEGER, save :: lmt_pas, julien, idayvrai
+!$OMP THREADPRIVATE(lmt_pas, julien, idayvrai) 
   REAL, parameter :: unjour=86400.
   real, allocatable, dimension(:), save :: tmp_tslab, tmp_seaice
   REAL, allocatable, dimension(:), save :: slab_bils
   REAL, allocatable, dimension(:), save :: lmt_bils
+!$OMP THREADPRIVATE(tmp_tslab, tmp_seaice,slab_bils,lmt_bils)
   logical,save              :: check = .false.
+!$OMP THREADPRIVATE(check) 
+
 !
   REAL, parameter :: cyang=50.0 * 4.228e+06 ! capacite calorifique volumetrique de l'eau J/(m2 K)
@@ -2317,7 +2667,11 @@
 !
   SUBROUTINE interfoce_lim(itime, dtime, jour, &
-     & klon, nisurf, knon, knindex, &
+     & klon_xx, nisurf, knon, knindex, &
      & debut,  &
-     & lmt_sst, pctsrf_new)
+     & lmt_sst_p, pctsrf_new_p)
+     
+     USE dimphy,klon=>klon2,klon2=>klon
+
+#include "indicesol.inc"
 
 ! Cette routine sert d'interface entre le modele atmospherique et un fichier
@@ -2346,13 +2700,16 @@
   real   , intent(IN) :: dtime
   integer, intent(IN) :: jour
+  integer, intent(in) :: klon_xx
   integer, intent(IN) :: nisurf
   integer, intent(IN) :: knon
-  integer, intent(IN) :: klon
-  integer, dimension(klon), intent(in) :: knindex
+  integer, dimension(klon2), intent(in) :: knindex
   logical, intent(IN) :: debut
 
 ! Parametres de sortie
-  real, intent(out), dimension(klon) :: lmt_sst
-  real, intent(out), dimension(klon,nbsrf) :: pctsrf_new
+  real, intent(out), dimension(klon2) :: lmt_sst_p
+  real, intent(out), dimension(klon2,nbsrf) :: pctsrf_new_p
+
+!  real, dimension(klon) :: lmt_sst
+  real, dimension(klon,nbsrf) :: pctsrf_new
 
 ! Variables locales
@@ -2360,16 +2717,30 @@
   INTEGER,save :: lmt_pas     ! frequence de lecture des conditions limites 
                              ! (en pas de physique)
+!$OMP THREADPRIVATE(lmt_pas)
   logical,save :: deja_lu    ! pour indiquer que le jour a lire a deja
                              ! lu pour une surface precedente
+!$OMP THREADPRIVATE(deja_lu)
   integer,save :: jour_lu 
+!$OMP THREADPRIVATE(jour_lu)
   integer      :: ierr
   character (len = 20) :: modname = 'interfoce_lim'
   character (len = 80) :: abort_message
   character (len = 20),save :: fich ='limit.nc'
+!$OMP THREADPRIVATE(fich)
   logical, save     :: newlmt = .TRUE.
+!$OMP THREADPRIVATE(newlmt)
   logical, save     :: check = .FALSE.
+!$OMP THREADPRIVATE(check)
 ! Champs lus dans le fichier de CL
-  real, allocatable , save, dimension(:) :: sst_lu, rug_lu, nat_lu
-  real, allocatable , save, dimension(:,:) :: pct_tmp
+  real, allocatable , save, dimension(:) :: sst_lu_p
+!$OMP THREADPRIVATE(sst_lu_p)
+  real, allocatable , save, dimension(:) :: sst_lu_mpi
+
+  real, allocatable , save, dimension(:,:) :: pct_tmp_p
+!$OMP THREADPRIVATE(pct_tmp_p)
+  real, allocatable , save, dimension(:,:) :: pct_tmp_mpi
+  real, dimension(klon,nbsrf) :: pct_tmp
+  real, dimension(klon) :: sst_lu
+  real, dimension(klon) :: nat_lu
 !
 ! quelques variables pour netcdf
@@ -2379,13 +2750,12 @@
   integer, dimension(2) :: start, epais
 !
-! Fin déclaration
-!
-    
-  if (debut .and. .not. allocated(sst_lu)) then
+! Fin declaration
+!
+  
+  if (debut .and. .not. allocated(sst_lu_p)) then
     lmt_pas = nint(86400./dtime * 1.0) ! pour une lecture une fois par jour
     jour_lu = jour - 1
-    allocate(sst_lu(klon))
-    allocate(nat_lu(klon))
-    allocate(pct_tmp(klon,nbsrf))
+    allocate(sst_lu_p(klon_omp))
+    allocate(pct_tmp_p(klon_omp,nbsrf))
   endif
 
@@ -2400,4 +2770,10 @@
 ! Ouverture du fichier
 !
+!$OMP MASTER
+    if (.not. allocated(sst_lu_mpi)) allocate(sst_lu_mpi(klon_mpi))
+    if (.not. allocated(pct_tmp_mpi)) allocate(pct_tmp_mpi(klon_mpi,nbsrf))
+    
+    if (phy_rank==0) then
+    
     fich = trim(fich)
     ierr = NF_OPEN (fich, NF_NOWRITE,nid)
@@ -2539,17 +2915,31 @@
 !
     ierr = NF_CLOSE(nid)
-    deja_lu = .true.
-    jour_lu = jour
-  endif
+   endif ! phyrank
 !
 ! Recopie des variables dans les champs de sortie
 !
-  lmt_sst = 999999999.
+  call ScatterField(sst_lu,sst_lu_mpi,1)
+  call ScatterField(pct_tmp(:,is_oce),pct_tmp_mpi(:,is_oce),1)
+  call ScatterField(pct_tmp(:,is_sic),pct_tmp_mpi(:,is_sic),1)
+!$OMP END MASTER
+!$OMP BARRIER
+  call ScatterField_omp(sst_lu_mpi,sst_lu_p,1)
+  call ScatterField_omp(pct_tmp_mpi(:,is_oce),pct_tmp_p(:,is_oce),1)
+  call ScatterField_omp(pct_tmp_mpi(:,is_sic),pct_tmp_p(:,is_sic),1)
+   deja_lu = .true.
+   jour_lu = jour
+  endif   
+  
+  lmt_sst_p = 999999999.
+  
   do ii = 1, knon
-    lmt_sst(ii) = sst_lu(knindex(ii))
+    lmt_sst_p(ii) = sst_lu_p(knindex(ii))
   enddo
 
-  pctsrf_new(:,is_oce) = pct_tmp(:,is_oce)
-  pctsrf_new(:,is_sic) = pct_tmp(:,is_sic)
+  do ii=1,klon2
+    pctsrf_new_p(ii,is_oce)=pct_tmp_p(ii,is_oce)
+    pctsrf_new_p(ii,is_sic)=pct_tmp_p(ii,is_sic)
+  enddo
+  
 
   END SUBROUTINE interfoce_lim
@@ -2559,7 +2949,9 @@
 !
   SUBROUTINE interfsur_lim(itime, dtime, jour, &
-     & klon, nisurf, knon, knindex, &
+     & klon_xx, nisurf, knon, knindex, &
      & debut,  &
-     & lmt_alb, lmt_rug)
+     & lmt_alb_p, lmt_rug_p)
+
+     USE dimphy,klon=>klon2,klon2=>klon
 
 ! Cette routine sert d'interface entre le modele atmospherique et un fichier
@@ -2581,5 +2973,5 @@
 !   lmt_sst      SST lues dans le fichier de CL
 !   lmt_alb      Albedo lu 
-!   lmt_rug      longueur de rugosité lue
+!   lmt_rug      longueur de rugosite lue
 !   pctsrf_new   sous-maille fractionnelle
 !
@@ -2592,11 +2984,14 @@
   integer, intent(IN) :: nisurf
   integer, intent(IN) :: knon
-  integer, intent(IN) :: klon
-  integer, dimension(klon), intent(in) :: knindex
+  integer, intent(IN) :: klon_xx
+  integer, dimension(klon2), intent(in) :: knindex
   logical, intent(IN) :: debut
 
 ! Parametres de sortie
-  real, intent(out), dimension(klon) :: lmt_alb
-  real, intent(out), dimension(klon) :: lmt_rug
+  real, intent(out), dimension(klon2) :: lmt_alb_p
+  real, intent(out), dimension(klon2) :: lmt_rug_p
+
+!  real,  dimension(klon) :: lmt_alb
+!  real,  dimension(klon) :: lmt_rug
 
 ! Variables locales
@@ -2604,15 +2999,24 @@
   integer,save :: lmt_pas     ! frequence de lecture des conditions limites 
                              ! (en pas de physique)
+!$OMP THREADPRIVATE(lmt_pas) 
   logical,save :: deja_lu_sur! pour indiquer que le jour a lire a deja
                              ! lu pour une surface precedente
+!$OMP THREADPRIVATE(deja_lu_sur) 
   integer,save :: jour_lu_sur 
+!$OMP THREADPRIVATE(jour_lu_sur) 
   integer      :: ierr
   character (len = 20) :: modname = 'interfsur_lim'
   character (len = 80) :: abort_message
   character (len = 20),save :: fich ='limit.nc'
+!$OMP THREADPRIVATE(fich) 
   logical,save     :: newlmt = .false.
+!$OMP THREADPRIVATE(newlmt) 
   logical,save     :: check = .false.
+!$OMP THREADPRIVATE(check) 
 ! Champs lus dans le fichier de CL
-  real, allocatable , save, dimension(:) :: alb_lu, rug_lu
+  real, allocatable , save, dimension(:) :: alb_lu_p, rug_lu_p
+!$OMP THREADPRIVATE(alb_lu_p, rug_lu_p) 
+  real, allocatable , save, dimension(:) :: alb_lu_mpi, rug_lu_mpi
+  real, dimension(klon) :: alb_lu, rug_lu
 !
 ! quelques variables pour netcdf
@@ -2620,14 +3024,16 @@
 #include "netcdf.inc"
   integer ,save             :: nid, nvarid
+!$OMP THREADPRIVATE(nid, nvarid) 
   integer, dimension(2),save :: start, epais
-!
-! Fin déclaration
-!
-    
+!$OMP THREADPRIVATE(start, epais) 
+!
+! Fin declaration
+!
+  
   if (debut) then
     lmt_pas = nint(86400./dtime * 1.0) ! pour une lecture une fois par jour
     jour_lu_sur = jour - 1
-    allocate(alb_lu(klon))
-    allocate(rug_lu(klon))
+    allocate(alb_lu_p(klon_omp))
+    allocate(rug_lu_p(klon_omp))
   endif
 
@@ -2640,4 +3046,9 @@
 ! Tester d'abord si c'est le moment de lire le fichier
   if (mod(itime-1, lmt_pas) == 0 .and. .not. deja_lu_sur) then
+
+!$OMP MASTER
+    if (.not. allocated(alb_lu_mpi)) allocate(alb_lu_mpi(klon_mpi))
+    if (.not. allocated(rug_lu_mpi)) allocate(rug_lu_mpi(klon_mpi))  
+  if (phy_rank==0) then
 !
 ! Ouverture du fichier
@@ -2676,6 +3087,5 @@
     endif
 !
-! Lecture rugosité
-!
+! Lecture rugosite !
     ierr = NF_INQ_VARID(nid, 'RUG', nvarid)
     if (ierr /= NF_NOERR) then
@@ -2697,7 +3107,22 @@
 !
     ierr = NF_CLOSE(nid)
+
+
+  endif  !! phyrank
+
+    call ScatterField(alb_lu,alb_lu_mpi,1)
+    call ScatterField(rug_lu,rug_lu_mpi,1)
+!$OMP END MASTER
+!$OMP BARRIER
+
+    call ScatterField_omp(alb_lu_mpi,alb_lu_p,1)
+    call ScatterField_omp(rug_lu_mpi,rug_lu_p,1)
+    
     deja_lu_sur = .true.
     jour_lu_sur = jour
+
+
   endif
+  
 !
 ! Recopie des variables dans les champs de sortie
@@ -2705,10 +3130,12 @@
 !!$  lmt_alb(:) = 0.0
 !!$  lmt_rug(:) = 0.0
-  lmt_alb(:) = 999999.
-  lmt_rug(:) = 999999.
+ 
+  lmt_alb_p(:) = 999999.
+  lmt_rug_p(:) = 999999.
   DO ii = 1, knon
-    lmt_alb(ii) = alb_lu(knindex(ii))
-    lmt_rug(ii) = rug_lu(knindex(ii))
+    lmt_alb_p(ii) = alb_lu_p(knindex(ii))
+    lmt_rug_p(ii) = rug_lu_p(knindex(ii))
   enddo
+
 
   END SUBROUTINE interfsur_lim
@@ -2724,5 +3151,5 @@
      & petAcoef, peqAcoef, petBcoef, peqBcoef, &
      & tsurf_new, evap, fluxlat, fluxsens, dflux_s, dflux_l)
-
+     USE dimphy,only : omp_rank
 ! Cette routine calcule les fluxs en h et q a l'interface et eventuellement
 ! une temperature de surface (au cas ou ok_veget = false)
@@ -2762,4 +3189,5 @@
 #include "FCTTRE.inc"
 #include "indicesol.inc"
+#include "YOMCST.inc"
 
 ! Parametres d'entree
@@ -2795,9 +3223,13 @@
 !
   logical, save         :: check = .false.
+!$OMP THREADPRIVATE(check)
   character (len = 20)  :: modname = 'calcul_fluxs'
   logical, save         :: fonte_neige = .false.
+!$OMP THREADPRIVATE(fonte_neige)
   real, save            :: max_eau_sol = 150.0
+!$OMP THREADPRIVATE(max_eau_sol)
   character (len = 80) :: abort_message 
   logical,save         :: first = .true.,second=.false.
+!$OMP THREADPRIVATE(first,second)
 
   if (check) write(*,*)'Entree ', modname,' surface = ',nisurf
@@ -2952,6 +3384,8 @@
 !#########################################################################
 !
-  SUBROUTINE gath2cpl(champ_in, champ_out, klon, knon, iim, jjm, knindex)
-
+  SUBROUTINE gath2cpl(champ_in, champ_out, klon, knon, iim, jmp1, knindex)
+  use dimphy, only: liste_i,liste_j,jjphy_begin,jjphy_nb,phy_rank,phy_size 
+  implicit none
+  
 ! Cette routine ecrit un champ 'gathered' sur la grille 2D pour le passer
 ! au coupleur.
@@ -2969,9 +3403,9 @@
 !
 ! input
-  integer                   :: klon, knon, iim, jjm
+  integer                   :: klon, knon, iim, jmp1
   real, dimension(klon)     :: champ_in
   integer, dimension(klon)  :: knindex
 ! output
-  real, dimension(iim,jjm+1)  :: champ_out
+  real, dimension(iim,jmp1)  :: champ_out
 ! local
   integer                   :: i, ig, j
@@ -2983,14 +3417,24 @@
     tamp(ig) = champ_in(i)
   enddo    
-  ig = 1
-  champ_out(:,1) = tamp(ig)
-  do j = 2, jjm
-    do i = 1, iim
-      ig = ig + 1
-      champ_out(i,j) = tamp(ig)
-    enddo
+
+!ym  ig = 1
+!ym  champ_out(:,1) = tamp(ig)
+!ym  do j = 2, jjm
+!ym    do i = 1, iim
+!ym      ig = ig + 1
+!ym      champ_out(i,j) = tamp(ig)
+!ym    enddo
+!ym  enddo
+!ym  ig = ig + 1
+!ym  champ_out(:,jjm+1) = tamp(ig)
+
+  do ig=1,klon
+    i=liste_i(ig)
+    j=liste_j(ig)-jjphy_begin+1
+    champ_out(i,j)=tamp(ig)
   enddo
-  ig = ig + 1
-  champ_out(:,jjm+1) = tamp(ig)
+  
+  if (phy_rank==0) champ_out(:,1)=tamp(1)
+  if (phy_rank==phy_size-1) champ_out(:,jjphy_nb)=tamp(klon)
 
   END SUBROUTINE gath2cpl
@@ -2998,6 +3442,7 @@
 !#########################################################################
 !
-  SUBROUTINE cpl2gath(champ_in, champ_out, klon, knon, iim, jjm, knindex)
-
+  SUBROUTINE cpl2gath(champ_in, champ_out, klon, knon, iim, jmp1, knindex)
+  use dimphy, only : liste_i, liste_j, jjphy_begin
+  implicit none
 ! Cette routine ecrit un champ 'gathered' sur la grille 2D pour le passer
 ! au coupleur.
@@ -3015,6 +3460,6 @@
 !
 ! input
-  integer                   :: klon, knon, iim, jjm
-  real, dimension(iim,jjm+1)     :: champ_in
+  integer                   :: klon, knon, iim, jmp1
+  real, dimension(iim,jmp1)     :: champ_in
   integer, dimension(klon)  :: knindex
 ! output
@@ -3024,16 +3469,23 @@
   real, dimension(klon)     :: tamp
   logical ,save                  :: check = .false.
-
-  ig = 1
-  tamp(ig) = champ_in(1,1)
-  do j = 2, jjm
-    do i = 1, iim
-      ig = ig + 1
-      tamp(ig) = champ_in(i,j)
-    enddo
+!$OMP THREADPRIVATE(check)
+
+!ym  ig = 1
+!ym  tamp(ig) = champ_in(1,1)
+!ym  do j = 2, jjm
+!ym    do i = 1, iim
+!ym      ig = ig + 1
+!ym      tamp(ig) = champ_in(i,j)
+!ym    enddo
+!ym  enddo
+!ym  ig = ig + 1
+!ym  tamp(ig) = champ_in(1,jjm+1)
+
+  do ig=1,klon
+   i=liste_i(ig)
+   j=liste_j(ig)-jjphy_begin+1
+   tamp(ig)=champ_in(i,j)
   enddo
-  ig = ig + 1
-  tamp(ig) = champ_in(1,jjm+1)
-
+  
   do i = 1, knon
     ig = knindex(i)
@@ -3057,4 +3509,5 @@
  
   REAL, DIMENSION(nvm),SAVE :: init, decay
+!$OMP THREADPRIVATE(init, decay)
   REAL :: as
   DATA init /0.55, 0.14, 0.18, 0.29, 0.15, 0.15, 0.14, 0./
@@ -3092,9 +3545,8 @@
      & petAcoef, peqAcoef, petBcoef, peqBcoef, &
      & tsurf_new, evap, fluxlat, fluxsens, dflux_s, dflux_l, &
-     & fqcalving,ffonte,run_off_lic_0)
+     & fqcalving,fqfonte,ffonte,run_off_lic_0)
 
 ! Routine de traitement de la fonte de la neige dans le cas du traitement
-! de sol simplifié
-!
+! de sol simplifie !
 ! LF 03/2001
 ! input:
@@ -3126,5 +3578,5 @@
 !   dflux_l      derivee du flux de chaleur latente  / Ts
 ! in/out:
-!   run_off_lic_0 run off glacier du pas de temps précedent
+!   run_off_lic_0 run off glacier du pas de temps precedent
 !
 
@@ -3152,7 +3604,7 @@
 ! Flux thermique utiliser pour fondre la neige
   real, dimension(klon), intent(INOUT):: ffonte
-! Flux d'eau "perdue" par la surface et necessaire pour que limiter la
-! hauteur de neige, en kg/m2/s
-  real, dimension(klon), intent(INOUT):: fqcalving
+! Flux d'eau "perdu" par la surface et necessaire pour que limiter la
+! hauteur de neige, en kg/m2/s. Et flux d'eau de fonte de la calotte.
+  REAL, DIMENSION(klon), INTENT(INOUT):: fqcalving, fqfonte
   real, dimension(klon), intent(INOUT):: run_off_lic_0
 ! Variables locales
@@ -3181,9 +3633,13 @@
 !
   logical, save         :: check = .FALSE.
+!$OMP THREADPRIVATE(check)
   character (len = 20)  :: modname = 'fonte_neige'
   logical, save         :: neige_fond = .false.
+!$OMP THREADPRIVATE(neige_fond)
   real, save            :: max_eau_sol = 150.0
+!$OMP THREADPRIVATE(max_eau_sol)
   character (len = 80) :: abort_message 
   logical,save         :: first = .true.,second=.false.
+!$OMP THREADPRIVATE(first,second)
   real                 :: coeff_rel
 #include "FCTTRE.inc"
@@ -3275,4 +3731,5 @@
       fq_fonte = MIN( MAX((tsurf_new(i)-RTT )/chasno,0.0),snow(i))
       ffonte(i) = fq_fonte * RLMLT/dtime
+      fqfonte(i) = fq_fonte/dtime
       snow(i) = max(0., snow(i) - fq_fonte)
       bil_eau_s(i) = bil_eau_s(i) + fq_fonte 
@@ -3283,5 +3740,8 @@
         fq_fonte = MAX((tsurf_new(i)-RTT )/chaice,0.0)
         ffonte(i) = ffonte(i) + fq_fonte * RLMLT/dtime
-        bil_eau_s(i) = bil_eau_s(i) + fq_fonte
+        IF ( ok_lic_melt ) THEN
+           fqfonte(i) = fqfonte(i) + fq_fonte/dtime
+           bil_eau_s(i) = bil_eau_s(i) + fq_fonte
+        ENDIF
         tsurf_new(i) = RTT
       ENDIF
@@ -3301,5 +3761,5 @@
  &                        (1. - coeff_rel) * run_off_lic_0(i)
       run_off_lic_0(i) = run_off_lic(i)
-      run_off_lic(i) = run_off_lic(i) + bil_eau_s(i)/dtime
+      run_off_lic(i) = run_off_lic(i) + fqfonte(i)/dtime
     endif
   enddo
Index: /LMDZ4/trunk/libf/phylmd/iophy.F90
===================================================================
--- /LMDZ4/trunk/libf/phylmd/iophy.F90	(revision 765)
+++ /LMDZ4/trunk/libf/phylmd/iophy.F90	(revision 766)
@@ -7,8 +7,11 @@
   REAL,private,allocatable,dimension(:),save :: io_lat
   REAL,private,allocatable,dimension(:),save :: io_lon
+  INTEGER, save :: phys_domain_id
   
   INTERFACE histwrite_phy
     MODULE PROCEDURE histwrite2d_phy,histwrite3d_phy
   END INTERFACE 
+  
+  REAL,private,allocatable,save,dimension(:,:) :: buffer_omp
 
 contains
@@ -16,9 +19,19 @@
   subroutine init_iophy(lat,lon)
   use dimphy
+  use ioipsl
   implicit none
   include 'dimensions90.h'   
     real,dimension(iim),intent(in) :: lon
     real,dimension(jjm+1),intent(in) :: lat
-  
+
+    INTEGER,DIMENSION(2) :: ddid
+    INTEGER,DIMENSION(2) :: dsg
+    INTEGER,DIMENSION(2) :: dsl
+    INTEGER,DIMENSION(2) :: dpf
+    INTEGER,DIMENSION(2) :: dpl
+    INTEGER,DIMENSION(2) :: dhs
+    INTEGER,DIMENSION(2) :: dhe 
+
+!$OMP MASTER  
     allocate(io_lat(jjm+1))
     io_lat(:)=lat(:)
@@ -31,5 +44,24 @@
     ndex2d(:)=0
     ndex3d(:)=0
+    allocate(buffer_omp(klon_mpi,klev))
+    
+    ddid=(/ 1,2 /)
+    dsg=(/ iim, jjm+1 /)
+    dsl=(/ iim, jjphy_nb /)
+    dpf=(/ 1,jjphy_begin /)
+    dpl=(/ iim, jjphy_end /)
+    dhs=(/ iiphy_begin-1,0 /)
+    if (phy_rank==phy_size-1) then
+      dhe=(/0,0/)
+    else
+      dhe=(/ iim-iiphy_end,0 /)  
+    endif
+    
+    call flio_dom_set(phy_size,phy_rank,ddid,dsg,dsl,dpf,dpl,dhs,dhe, &
+                      'APPLE',phys_domain_id)
 
+!$OMP END MASTER
+!$OMP FLUSH(buffer_omp)
+      
   end subroutine init_iophy
   
@@ -47,12 +79,14 @@
     integer,intent(out) :: nhori
     integer,intent(out) :: nid_day
-    
+
+!$OMP MASTER    
     if (monocpu) then
       call histbeg(name,iim,io_lon, jjphy_nb,io_lat(jjphy_begin:jjphy_end), &
                    1,iim,1,jjphy_nb,itau0, zjulian, dtime, nhori, nid_day)
     else
-      call histbeg(name//'_'//trim(int2str(phy_rank)),iim,io_lon, jjphy_nb,io_lat(jjphy_begin:jjphy_end), &
-                   1,iim,1,jjphy_nb,itau0, zjulian, dtime, nhori, nid_day)
+      call histbeg(name,iim,io_lon, jjphy_nb,io_lat(jjphy_begin:jjphy_end), &
+                   1,iim,1,jjphy_nb,itau0, zjulian, dtime, nhori, nid_day,phys_domain_id)
     endif
+!$OMP END MASTER
   
   end subroutine histbeg_phy
@@ -68,8 +102,10 @@
     integer, intent(in) :: itau
     real,dimension(klon),intent(in) :: field
-    
-    CALL phy2dyn(field,tmp_tab2d,1)
+
+    CALL GatherField_omp(field,buffer_omp,1)    
+!$OMP MASTER
+    CALL phy2dyn(buffer_omp,tmp_tab2d,1)
     CALL histwrite(nid,name,itau,tmp_tab2d,iim*jjphy_nb,ndex2d)
-    
+!$OMP END MASTER    
   end subroutine histwrite2d_phy
   
@@ -85,7 +121,9 @@
     real,dimension(klon,klev),intent(in) :: field
     
-    CALL phy2dyn(field,tmp_tab3d,klev)
+    CALL GatherField_omp(field,buffer_omp,klev)
+!$OMP MASTER
+    CALL phy2dyn(buffer_omp,tmp_tab3d,klev)
     CALL histwrite(nid,name,itau,tmp_tab3d,iim*jjphy_nb*klev,ndex3d)
-    
+!$OMP END MASTER    
   end subroutine histwrite3d_phy
   
@@ -96,5 +134,5 @@
   include 'dimensions90.h'
   
-    real,dimension(klon,nlev),intent(in) :: field_phy
+    real,dimension(klon_mpi,nlev),intent(in) :: field_phy
     real,dimension(iim,jjphy_nb,nlev),intent(out) :: field_dyn
     integer,intent(in) :: nlev
@@ -107,5 +145,5 @@
 	if (jjphy_begin==jjphy_end) then
 	  field_dyn(:,1,l)=0.
-	  field_dyn(iiphy_begin:iiphy_end,1,l)=field_phy(1:klon,l)
+	  field_dyn(iiphy_begin:iiphy_end,1,l)=field_phy(1:klon_mpi,l)
 	else
 	
@@ -115,5 +153,5 @@
 	 else
 	   field_dyn(:,1,l)=0.
-	   next=iim-iiphy_begin+1
+	   next=iim-iiphy_begin+2
 	   field_dyn(iiphy_begin:iim,1,l)=field_phy(1:next-1,l)   
 	 endif
@@ -125,5 +163,5 @@
 	  
 	  if (jjphy_end==jjm+1) then
-             field_dyn(:,jjphy_nb,l)=field_phy(klon,l)
+             field_dyn(:,jjphy_nb,l)=field_phy(klon_mpi,l)
 	  else
 	   field_dyn(:,jjphy_nb,l)=0.
Index: /LMDZ4/trunk/libf/phylmd/minmaxqfi.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/minmaxqfi.F	(revision 765)
+++ /LMDZ4/trunk/libf/phylmd/minmaxqfi.F	(revision 766)
@@ -3,8 +3,9 @@
 !
       SUBROUTINE minmaxqfi(zq,qmin,qmax,comment)
+      USE dimphy
       IMPLICIT none
 
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 
       CHARACTER*(*) comment
